; oGet setup 1.9.9 by A.Ruzanov
; 14.04.2007



#NoTrayIcon

If @OSLang = 0419 Then
	$MP = "    Opera"
	$Merror = "   OperaDef6.ini"
	$MUSD = " ,      USDownloader.exe"
	$MOK = "  "
	$MDL = '"Закачать с oGet"'
	$MDS = '"Закачать выделенное с oGet"'
	$MDALL = '"Закачать всё с oGet"'
	$MSDM = '"Менеджеры закачки"'
	$MDTL = '"Закачать текстовую ссылку с oGet"'
	$MDAI = '"Закачать все картинки с oGet"'
Else
	$MP = "Select a Opera folder in the list below, then click OK."
	$Merror = "Not found OperaDef6.ini"
	$MUSD = "If needed, specify a way to the file of USDownloader.exe"
	$MOK = "Setup has finished installing oGet on your computer"
	$MDL = '"Download with oGet"'
	$MDS = '"Download Selection with oGet"'
	$MDALL = '"Download All with oGet"'
	$MSDM = '"Select Download Manager"'
	$MDTL = '"Download Text Link with oGet"'
	$MDAI = '"Download All Images with oGet"'
EndIf

$StartDir = @ScriptDir
If Not FileExists($StartDir & "\opera.exe") Then
	$StartDirArr = StringSplit(StringLower(RegRead("HKEY_CURRENT_USER\Software\Opera Software", "Last CommandLine v2")), "\opera.exe ", 1)
	If IsArray($StartDirArr) Then $StartDir = $StartDirArr[1]
EndIf
If Not FileExists($StartDir & "\opera.exe") Then $StartDir = RegRead("HKEY_CURRENT_USER\Software\Opera Software", "Last Directory3")
If Not FileExists($StartDir & "\opera.exe") Then $StartDir = ""

$OperaDir = FileSelectFolder($MP, "", 0, $StartDir)
If @error Then Exit

Select
	Case IniRead($OperaDir & "\OperaDef6.ini", "System", "Multi User", "-1") = 1
		$VarOpDir = StringSplit($OperaDir, "\")
		$NameDir = $VarOpDir[UBound($VarOpDir) - 1]
		$VarMenu = @AppDataDir & "\opera\" & $NameDir & "\profile\menu\"
		$VarOpera6 = @AppDataDir & "\opera\" & $NameDir & "\profile\opera6.ini"
	Case IniRead($OperaDir & "\OperaDef6.ini", "System", "Multi User", "-1") = 0
		$VarMenu = $OperaDir & "\profile\menu\"
		$VarOpera6 = $OperaDir & "\profile\opera6.ini"
	Case IniRead($OperaDir & "\OperaDef6.ini", "System", "Multi User", "-1") = -1
		MsgBox(48, "Error", $Merror)
		Exit
EndSelect


DirCreate($OperaDir & "\scripts")
FileInstall("FlashGot.exe", $OperaDir & "\scripts\FlashGot.exe", 1)
FileInstall("clip2txt.exe", $OperaDir & "\scripts\clip2txt.exe", 1)
If @OSLang = 0419 Then
	FileInstall("oGet.vbs", $OperaDir & "\scripts\oGet.vbs", 1)
Else
	FileInstall("oGet_Eng.vbs", $OperaDir & "\scripts\oGet.vbs", 1)
EndIf

$PathToUSD = FileOpenDialog($MUSD, @ProgramFilesDir, "Program files (*.exe)")
If @error Then $PathToUSD = ""

$file = FileOpen($OperaDir & "\scripts\oGet.ini", 2)
FileWriteLine($file, "")
FileWriteLine($file, $PathToUSD)
FileClose($file)

$VarDefMenu = $OperaDir & "\defaults\standard_menu.ini"

$VarSearchM = FileFindFirstFile($VarMenu & "*.ini")
If $VarSearchM = -1 Then
	$VarOperaMenu = $VarDefMenu
	Correct($VarOperaMenu, $VarDefMenu, $OperaDir)
Else
	While 1
		$VarOperaMenu = $VarMenu & FileFindNextFile($VarSearchM)
		If @error Then ExitLoop
		Correct($VarOperaMenu, $VarDefMenu, $OperaDir)
	WEnd
	FileClose($VarSearchM)
EndIf

MsgBox(64, "oGet setup", $MOK, 10)
Exit

Func Transfer($Home)
	$VarBTM = IniReadSection($VarOperaMenu, $Home)
	If @error Then
		$VarHNDL = FileOpen($VarOperaMenu, 1)
		$VarDefHNDL = FileOpen($VarDefMenu, 0)
		$BTM = ""
		While $BTM <> "[" & $Home & "]"
			$BTM = FileReadLine($VarDefHNDL)
		WEnd
		
		$BTM = @CRLF & $BTM
		
		Do
			FileWriteLine($VarHNDL, $BTM)
			$BTM = FileReadLine($VarDefHNDL)
		Until StringLeft($BTM, 1) = "[" Or StringLeft($BTM, 2) = ";["
		FileClose($VarHNDL)
		FileClose($VarDefHNDL)
	EndIf
EndFunc   ;==>Transfer

Func Correct($VarOperaMenu, $VarDefMenu, $OperaDir)
	$VarBak = $VarOperaMenu & "_1.bak"
	If FileExists($VarBak) Then
		$Num = 2
		While FileExists($VarOperaMenu & "_" & $Num & ".bak")
			$Num = $Num + 1
		WEnd
		$VarBak = $VarOperaMenu & "_" & $Num & ".bak"
	EndIf
	
	FileCopy($VarOperaMenu, $VarBak, 1)
	
	Transfer("Link Popup Menu")
	Transfer("Image Link Popup Menu")
	Transfer("Hotclick Popup Menu")
	Transfer("Document Popup Menu")
	Transfer("Browser Tools Menu")
	Transfer("Links Panel Item Menu")
	
	IniDelete($VarOperaMenu, "Link Popup Menu", 'Platform Windows, Item, "Download with oGet"')
	IniWrite($VarOperaMenu, "Link Popup Menu", 'Platform Windows, Item, ' & $MDL, '"Execute program, "' & $OperaDir & '\scripts\oget.vbs", "%l %u %T",,"Save" "')
	
	IniDelete($VarOperaMenu, "Image Link Popup Menu", 'Platform Windows, Item, "Download with oGet"')
	IniWrite($VarOperaMenu, "Image Link Popup Menu", 'Platform Windows, Item, ' & $MDL, '"Execute program, "' & $OperaDir & '\scripts\oget.vbs", "%l %u %T",,"Save" "')
	
	IniDelete($VarOperaMenu, "Hotclick Popup Menu", 'Platform Windows, Item, "Download with oGet"')
	IniDelete($VarOperaMenu, "Hotclick Popup Menu", 'Platform Windows, Item, "Закачать ссылку с oGet"')
	IniWrite($VarOperaMenu, "Hotclick Popup Menu", 'Platform Windows, Item, ' & $MDTL, '"Execute program, "' & $OperaDir & '\scripts\oget.vbs", "%T %u %T",,"Save" "')
	
	IniDelete($VarOperaMenu, "Hotclick Popup Menu", 'Platform Windows, Item, "Download Selection with oGet"')
	If StringLeft(FileGetVersion($OperaDir & "\Opera.dll"), 1) > 8 Then IniWrite($VarOperaMenu, "Hotclick Popup Menu", 'Platform Windows, Item, ' & $MDS, '"Execute program, "' & $OperaDir & '\scripts\clip2txt.exe","%u",,"Save" & Go to Page, "javascript:(function(){var lnks, text, re, rearray; var a_links=''''; var t_links=''''; var html_selection=document.createElement(''div''); html_selection.appendChild(window.getSelection().getRangeAt(0).cloneContents()); lnks = html_selection.getElementsByTagName(''a''); for(var i=0, li; li=lnks[i]; i++){a_links+= ''<a href=\x22''+li.href+''\x22>''+li.innerText+''</a>''}; text=html_selection.innerText.replace(/h..p:\/\//gi,''http://'').replace(/f.p:\/\//gi,''ftp://''); re=/((?:https|http|ftp|mms|rtsp):\/\/[^\s\x22<>\{\}\''\(\)]+)/gi; while(rearray=re.exec(text)){t_links+= ''<a href=\x22''+rearray[1]+''\x22></a>''}; prompt(''Please wait...'', a_links+t_links);})()" "')
	
	IniDelete($VarOperaMenu, "Document Popup Menu", 'Platform Windows, Item, "Download All with oGet"')
	IniWrite($VarOperaMenu, "Document Popup Menu", 'Platform Windows, Item, ' & $MDALL, '"Execute program, "' & $OperaDir & '\scripts\oget.vbs", "%u %S DOWNLOAD ALL",,"Save" "')
	IniWrite($VarOperaMenu, "Document Popup Menu", 'Platform Windows, Item, ' & $MDAI, '"Execute program, "' & $OperaDir & '\scripts\oget.vbs", "%u %S DOWNLOAD IMG",,"Save" "')
	
	IniDelete($VarOperaMenu, "Browser Tools Menu", 'Platform Windows, Submenu, "Select Download Manager", Downloaders Menu')
	IniWrite($VarOperaMenu, "Browser Tools Menu", 'Platform Windows, Submenu, ' & $MSDM & ', Downloaders Menu', '"Show popup menu,,,, "Save""')
	
	IniWrite($VarOperaMenu, "Links Panel Item Menu", '--------------------', '')
	IniWrite($VarOperaMenu, "Links Panel Item Menu", 'Platform Windows, Item, ' & $MDL, '"Execute program, "' & $OperaDir & '\scripts\oget.vbs", "%l %u %T",,"Save" "')
	IniWrite($VarOperaMenu, "Links Panel Item Menu", 'Platform Windows, Item, ' & $MDALL, '"Execute program, "' & $OperaDir & '\scripts\oget.vbs", "%u %S DOWNLOAD ALL",,"Save" "')
	IniWrite($VarOperaMenu, "Links Panel Item Menu", 'Platform Windows, Item, ' & $MDAI, '"Execute program, "' & $OperaDir & '\scripts\oget.vbs", "%u %S DOWNLOAD IMG",,"Save" "')
	
	IniWrite($VarOperaMenu, "Downloaders Menu", 'Platform Windows, Item, "BitComet"', '"Execute program, "' & $OperaDir & '\scripts\oget.vbs", "setup BitComet",,"BitComet" "')
	IniWrite($VarOperaMenu, "Downloaders Menu", 'Platform Windows, Item, "Download Accelerator Plus"', '"Execute program, "' & $OperaDir & '\scripts\oget.vbs", "setup Download Accelerator Plus",,"dap" "')
	IniWrite($VarOperaMenu, "Downloaders Menu", 'Platform Windows, Item, "Download Master"', '"Execute program, "' & $OperaDir & '\scripts\oget.vbs", "setup Download_Master",,"dmaster" "')
	IniWrite($VarOperaMenu, "Downloaders Menu", 'Platform Windows, Item, "Flashget"', '"Execute program, "' & $OperaDir & '\scripts\oget.vbs", "setup FlashGet",,"flashget" "')
	IniWrite($VarOperaMenu, "Downloaders Menu", 'Platform Windows, Item, "Free Download Manager"', '"Execute program, "' & $OperaDir & '\scripts\oget.vbs", "setup Free_Download_Manager",,"fdm" "')
	IniWrite($VarOperaMenu, "Downloaders Menu", 'Platform Windows, Item, "FreshDownload"', '"Execute program, "' & $OperaDir & '\scripts\oget.vbs", "setup FreshDownload",,"FreshDownload" "')
	IniWrite($VarOperaMenu, "Downloaders Menu", 'Platform Windows, Item, "GetRight"', '"Execute program, "' & $OperaDir & '\scripts\oget.vbs", "setup GetRight",,"GetRight" "')
	IniWrite($VarOperaMenu, "Downloaders Menu", 'Platform Windows, Item, "GigaGet"', '"Execute program, "' & $OperaDir & '\scripts\oget.vbs", "setup GigaGet",,"GigaGet" "')
	IniWrite($VarOperaMenu, "Downloaders Menu", 'Platform Windows, Item, "HiDownload"', '"Execute program, "' & $OperaDir & '\scripts\oget.vbs", "setup HiDownload",,"HiDownload" "')
	IniWrite($VarOperaMenu, "Downloaders Menu", 'Platform Windows, Item, "InstantGet"', '"Execute program, "' & $OperaDir & '\scripts\oget.vbs", "setup InstantGet",,"InstantGet" "')
	IniWrite($VarOperaMenu, "Downloaders Menu", 'Platform Windows, Item, "Internet Download Accelerator"', '"Execute program, "' & $OperaDir & '\scripts\oget.vbs", "setup Internet_Download_Accelerator",,"ida" "')
	IniWrite($VarOperaMenu, "Downloaders Menu", 'Platform Windows, Item, "Internet Download Manager"', '"Execute program, "' & $OperaDir & '\scripts\oget.vbs", "setup Internet_Download_Manager",,"idm" "')
	IniWrite($VarOperaMenu, "Downloaders Menu", 'Platform Windows, Item, "LeechGet"', '"Execute program, "' & $OperaDir & '\scripts\oget.vbs", "setup LeechGet",,"LeechGet" "')
	IniWrite($VarOperaMenu, "Downloaders Menu", 'Platform Windows, Item, "Mass Downloader"', '"Execute program, "' & $OperaDir & '\scripts\oget.vbs", "setup Mass_Downloader",,"MassDownloader" "')
	IniWrite($VarOperaMenu, "Downloaders Menu", 'Platform Windows, Item, "NetAnts"', '"Execute program, "' & $OperaDir & '\scripts\oget.vbs", "setup NetAnts",,"NetAnts" "')
	IniWrite($VarOperaMenu, "Downloaders Menu", 'Platform Windows, Item, "Net Transport"', '"Execute program, "' & $OperaDir & '\scripts\oget.vbs", "setup Net_Transport",,"NetTransport" "')
	IniWrite($VarOperaMenu, "Downloaders Menu", 'Platform Windows, Item, "Net Transport 2"', '"Execute program, "' & $OperaDir & '\scripts\oget.vbs", "setup Net_Transport_2",,"NetTransport2" "')
	IniWrite($VarOperaMenu, "Downloaders Menu", 'Platform Windows, Item, "Orbit"', '"Execute program, "' & $OperaDir & '\scripts\oget.vbs", "setup Orbit",,"Orbit" "')
	IniWrite($VarOperaMenu, "Downloaders Menu", 'Platform Windows, Item, "ReGet"', '"Execute program, "' & $OperaDir & '\scripts\oget.vbs", "setup ReGet",,"ReGet" "')
	IniWrite($VarOperaMenu, "Downloaders Menu", 'Platform Windows, Item, "Star Downloader"', '"Execute program, "' & $OperaDir & '\scripts\oget.vbs", "setup Star_Downloader",,"StarDownloader" "')
	IniWrite($VarOperaMenu, "Downloaders Menu", 'Platform Windows, Item, "TrueDownloader"', '"Execute program, "' & $OperaDir & '\scripts\oget.vbs", "setup TrueDownloader",,"TrueDownloader" "')
	IniWrite($VarOperaMenu, "Downloaders Menu", 'Platform Windows, Item, "Thunder"', '"Execute program, "' & $OperaDir & '\scripts\oget.vbs", "setup Thunder",,"Thunder" "')
	IniWrite($VarOperaMenu, "Downloaders Menu", 'Platform Windows, Item, "Thunder (Old)"', '"Execute program, "' & $OperaDir & '\scripts\oget.vbs", "setup Thunder_(Old)",,"Thunder" "')

	IniWrite($VarOperaMenu, "Downloaders Menu", 'Platform Windows, Item, "WellGet"', '"Execute program, "' & $OperaDir & '\scripts\oget.vbs", "setup WellGet",,"WellGet" "')
	IniWrite($VarOperaMenu, "Downloaders Menu", 'Platform Windows, Item, "wxDownload Fast"', '"Execute program, "' & $OperaDir & '\scripts\oget.vbs", "setup wxDownload_Fast",,"wxdfast" "')
	
EndFunc   ;==>Correct
